unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, ComCtrls;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    Button1: TButton;
    ScrollBox1: TScrollBox;
    Image1: TImage;
    HotKey1: THotKey;
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
  private
    procedure ScreenShot();
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

uses
    iCoolKey, //  TCoolKeys
    Menus, Types     //  ShortCutToKey֐̂߂
    ;

var
    CoolKey: TCoolKeys = nil;

//  ---------------------------------------------------------------------------
//  }EXJ[\`揈
//  http://halbow.cool.ne.jp/Notes/N009.html
procedure DrawMouseCursor(const R: TRect; DC: HDC);
var
    CI: TCursorInfo;
    II: TIconInfo;
begin
    //  J[\1
    CI.cbSize := SizeOf(TCursorInfo);
    CI.flags := CURSOR_SHOWING;
    GetCursorInfo(CI);
    //  J[\2
    II.fIcon := false;
    GetIconInfo(CI.hCursor,II);
    DeleteObject(II.hbmColor);
    DeleteObject(II.hbmMask);
    //  zbgX|bgŒ
    CI.ptScreenPos := Point(
        CI.ptScreenPos.x - integer(II.xHotspot),
        CI.ptScreenPos.y - integer(II.yHotspot)
    );
    //  ␳
    CI.ptScreenPos := Point(CI.ptScreenPos.x - R.Left, CI.ptScreenPos.y - R.Top);
    //  `
    DrawIconEx(DC, CI.ptScreenPos.x, CI.ptScreenPos.y, CI.hCursor,
                0, 0, 0, 0, DI_DEFAULTSIZE or DI_NORMAL);
end;

//  ---------------------------------------------------------------------------
//  FormCreate
procedure TForm1.FormCreate(Sender: TObject);
var
    Shift: TShiftState;
    Key: Word;
begin
    //  zbgL[𕪉
    ShortCutToKey(HotKey1.HotKey, Key, Shift);
    //  zbgL[NXɓo^
    CoolKey.Add(ScreenShot, Shift, Key);
end;

//  ---------------------------------------------------------------------------
//  zbgL[ύX
procedure TForm1.Button1Click(Sender: TObject);
var
    Shift: TShiftState;
    Key: Word;
begin
    //  ŏ̂
    CoolKey.Delete(0);
    //  VL[zbgL[NXɓo^
    ShortCutToKey(HotKey1.HotKey, Key, Shift);
    CoolKey.Add(ScreenShot, Shift, Key);
end;


//-----------------------------------------------------------------------------
//  EBhË̗
function GetWindowR(const WH: HWND): TRect;
var
    WI: TWindowInfo;
begin
    //  EBhE擾
    GetWindowInfo(WH, WI);
    //  傫擾
    Result := WI.rcWindow;
end;

//-----------------------------------------------------------------------------
//  fXNgbvŜLv`[
procedure CapturerDesktop(Dest: TBitmap);
var
    WH: HWND;
    DC: HDC;
    R: TRect;
begin
    //  EBhEnh擾
    WH := GetDesktopWindow();
    //  foCXReLXg擾
    DC := GetWindowDC(WH);
    //  傫擾
    R := GetWindowR(WH);
    //  TCY낦
    Dest.Width := R.Right - R.Left;
    Dest.Height := R.Bottom - R.Top;
    // `
    BitBlt(Dest.Canvas.Handle, 0, 0, Dest.Width, Dest.Height, DC, 0, 0, SRCCOPY);
    // }EXJ[\`
    DrawMouseCursor(R, Dest.Canvas.Handle);
    // DC̊J
    ReleaseDC(WH, DC);
end;

//  ---------------------------------------------------------------------------
//  EBhEnhi[pz
type
    PHWndArray = ^THWndArray;
    THWndArray = array[0..500] of HWND;

//-----------------------------------------------------------------------------
//  EBhẼNXo
//  http://homepage2.nifty.com/Mr_XRAY/Halbow/VCL06.html
function GetClassNameStr(Handle:HWND):string;
var
    Len:integer;
    PC:PChar;
begin
    GetMem(PC,100);
    Len := GetClassName(Handle,PC,100);
    SetString(result,PC,Len);
    FreeMem(PC);
end;

//-----------------------------------------------------------------------------
//  j[񋓂
function EnumMenuWindow(var WA: THWndArray):integer;
var
    hWindow:HWND;
    ClsName: string;
begin
    //  z̐擪ɂ͎擾
    WA[0] := 0;
    //  ڂo
    hWindow := GetWindow(Application.Handle, GW_HWNDFIRST);
    //  
    while (hWindow <> 0) do
    begin
        //  NXo
        ClsName := GetClassNameStr(hWindow);
        //  j[̃NX́Aǂ #32768 炵̂
        if ClsName = '#32768' then
        begin
            //  擾CNg
            WA[0] := WA[0] + 1;
            //  ̈ʒuɂ̃nhi[
            WA[WA[0]] := hWindow
        end;
        //  
        hWindow := GetWindow(hWindow,GW_HWNDNEXT);
    end;
    //  ƂȂ擾߂
    result := WA[0];
end;

//  ---------------------------------------------------------------------------
//  {
procedure TForm1.ScreenShot();
var
    i: integer;
    DtBmp: TBitmap;
    WA: THWndArray;
    ResultRgn: HRGN;
    WorkRgn: HRGN;
    R, ResultR: TRect;
    DtBmp2: TBitmap;
begin
    //-------------------------------------------
    //  fXNgbvŜLv`
    DtBmp := TBitmap.Create;
    CapturerDesktop(DtBmp);

    //-------------------------------------------
    //  ŏIrbg}bv
    DtBmp2 := TBitmap.Create;
    DtBmp2.Width := DtBmp.Width;
    DtBmp2.Height := DtBmp.Height;

    //-------------------------------------------
    //  j[EBhẼnh擾
    FillChar(WA, SizeOf(WA), 0);
    EnumMenuWindow(WA);

    //-------------------------------------------
    //  őOʃEBhẼnh擾
    Inc(WA[0]);
    WA[WA[0]] := GetForegroundWindow();

    //-------------------------------------------
    //  ̃[W쐬(͓̈K)
    //  CombineRgn̎󂯎MƂ邽
    ResultRgn := CreateRectRgn(0, 0, 0, 0);

    //-------------------------------------------
    //  eEBhË̗挋
    for i := 1 to WA[0] do
    begin
        //  EBhË擾
        R := GetWindowR(WA[i]);

        //  Ɨp[W쐬
        WorkRgn := CreateRectRgnIndirect(R);

        //  
        CombineRgn(ResultRgn, ResultRgn, WorkRgn, RGN_OR);

        //  Ɨp[Wj
        DeleteObject(WorkRgn);
    end;

    //-------------------------------------------
    //  fXNgbv̔wiœhԂ
    //PaintDesktop(DtBmp2.Canvas.Handle);
    //PaintDesktop(Image1.Canvas.Handle);
    //BitBlt(DtBmp2.Canvas.Handle, 0, 0, DtBmp2.Width, DtBmp2.Height,
    //        Image1.Canvas.Handle, 0, 0, SRCCOPY);
    DtBmp2.Canvas.FillRect(Rect(0, 0, DtBmp2.Width, DtBmp2.Height));

    //-------------------------------------------
    //  [WŃNbsO
    SelectClipRgn(DtBmp2.Canvas.Handle, ResultRgn);
    //  `
    DtBmp2.Canvas.Draw(0, 0, DtBmp);
    //  [WJo[MM̋`擾
    GetClipBox(DtBmp2.Canvas.Handle, ResultR);
    //  NbsO~
    SelectClipRgn(DtBmp2.Canvas.Handle, 0);
    //  ɖړỈ摜]
    BitBlt(DtBmp2.Canvas.Handle, 0, 0,
            ResultR.Right - ResultR.Left,
            ResultR.Bottom - ResultR.Top,
            DtBmp2.Canvas.Handle,
            ResultR.Left, ResultR.Top,
            SRCCOPY);
    //  TCY̑傫ɂ낦
    DtBmp2.Width := ResultR.Right - ResultR.Left;
    DtBmp2.Height := ResultR.Bottom - ResultR.Top;

    //-------------------------------------------
    //  `
    Image1.Width := DtBmp2.Width;
    Image1.Height := DtBmp2.Height;
    Image1.Picture.Bitmap.Width := DtBmp2.Width;
    Image1.Picture.Bitmap.Height := DtBmp2.Height;
    BitBlt(Image1.Picture.Bitmap.Canvas.Handle, 0, 0,
          DtBmp2.Width, DtBmp2.Height, DtBmp2.Canvas.Handle, 0, 0, SRCCOPY);

    //-------------------------------------------
    //  o
    DtBmp2.SaveToFile(ChangeFileExt(ParamStr(0), IntToStr(GetTickCount) + '.bmp'));

    //-------------------------------------------
    //  IuWFNgj
    DtBmp.Free;
    DtBmp2.Free;
    DeleteObject(ResultRgn);
end;


//  ---------------------------------------------------------------------------
//  /I
initialization
    CoolKey := TCoolKeys.Create();
finalization
    CoolKey.Free;
end.
